class Network{
  ArrayList<Neuron> neurons;
  ArrayList<Particle> particles;
  
  Network(){
    neurons = new ArrayList<Neuron>();
    particles = new ArrayList<Particle>();
  }
  
  void addNeuron(Neuron n){
    neurons.add(n);
  }
  
  void display(){
    for(Neuron n: neurons){
      n.display();
    }
    for(Particle p:particles){
      p.display();
    }
  }
  
  void feedforward(float input){
    Neuron start = neurons.get(0);
    start.feedforward(input);
  }
  
  void update(){
    for (Neuron n: neurons){
      n.update(particles);
    }
    Iterator<Particle> it = particles.iterator();
    while(it.hasNext()){
      Particle p = it.next();
      p.update();
      if(p.isDead){
        it.remove();
      }
    }
    applyForces();
  }
  
  void applyForces(){
    Iterator<Particle> it = particles.iterator();
    while(it.hasNext()){
      Particle p = it.next();
      for (Neuron n: neurons){
        p.neuronAttract(n);
        p.neuronTransmit(n);
      }
    }
  }
  
}
