class Neuron{
  PVector location;
  //ArrayList<Particle> particles;
  float sum =0;
  float size;
  float[] weights;
  boolean readyToFire =false;
 
  Neuron(float x, float y,int numWeights){
    location = new PVector(x,y);
    //particles = new ArrayList<Particle>();
    size = maxNeuronSize;
    weights = new float[numWeights];
    createWeights();
  }
  
  void display(){
    noStroke();
    fill(255,90,90);
    ellipse(location.x,location.y,size,size);
//    for(Particle p: particles){
//      p.display();
//    }
  }
  
  void feedforward(float input){
    sum += input;
    if(sum>1){
      readyToFire = true;
    }
  }
  
  void fire(ArrayList<Particle> parts){
    int w = int(random(weights.length));
    float value = weights[w];
    PVector startVel = new PVector(0,5);
    float angle = map(value,0,1,0,TWO_PI);
    startVel.rotate(angle);
    value *= sum;
    Particle f = new Particle(value,location,startVel);
    parts.add(f);
    println(angle);
    readyToFire = false;
    sum = 0;
  }
  
  void update(ArrayList<Particle> p){
    size = maxNeuronSize-(sum*maxNeuronSize)+minNeuronSize;
//    for(Particle p: particles){
//      p.update();
//    }
    if (readyToFire) fire(p);
  }
  
  void createWeights(){
    for(int i=0;i<weights.length;i++){
      weights[i] = random(1);
    }
  }
}
      
  
