class Particle{
  
  float output;
  PVector startLoc;
  PVector location, velocity, acceleration;
  boolean isDead = false;
  
  Particle(float o, PVector loc, PVector vel){
    acceleration = new PVector(0,0);
    velocity = vel;
    startLoc = loc;
    location = startLoc.get();
    output = o;
  }
  
  void update(){
    velocity.add(acceleration);
    velocity.limit(30);
    location.add(velocity);
    acceleration.mult(0);
    checkEdges();
  }
  
  void applyForce(PVector force){
    PVector f = force.get();
    acceleration.add(f);
  }
  
  void display(){
    noStroke();
    fill(2,221,227);
    ellipse(location.x,location.y,5,5);
  }
  
  void neuronAttract(Neuron n){
    if(n.location != startLoc){
      PVector dir = PVector.sub(location,n.location);
      float d = dir.mag();
      d = constrain(d,minForce,maxForce);
      dir.normalize();
      float force = -(n.size/(d*d));
      dir.mult(force);
      applyForce(dir);
    }
  }
  
  void neuronTransmit(Neuron n){
    if(n.location != startLoc){
      float seperation = PVector.dist(location,n.location);
      if(abs(seperation)<n.size/2){
        n.feedforward(output);
        isDead = true;
      }
    }
  }
  
  void checkEdges(){
    if(location.x<0 || location.x>width){
      velocity.x *=-1;
    }
    if(location.y<0 || location.y>height){
     velocity.y *=-1;
    }
  } 
}
  
    
    
    
  
  
